Skip to content
Projects
Groups
Snippets
Help
Loading...
Help
Support
Keyboard shortcuts
?
Submit feedback
Contribute to GitLab
Sign in / Register
Toggle navigation
C
cpython
Project overview
Project overview
Details
Activity
Releases
Repository
Repository
Files
Commits
Branches
Tags
Contributors
Graph
Compare
Issues
0
Issues
0
List
Boards
Labels
Milestones
Merge Requests
0
Merge Requests
0
Analytics
Analytics
Repository
Value Stream
Wiki
Wiki
Members
Members
Collapse sidebar
Close sidebar
Activity
Graph
Create a new issue
Commits
Issue Boards
Open sidebar
Kirill Smelkov
cpython
Commits
844a3acc
Commit
844a3acc
authored
Jun 14, 2003
by
Martin v. Löwis
Browse files
Options
Browse Files
Download
Email Patches
Plain Diff
Patch #746366: Update to current automake install-sh. Will backport to 2.2.
parent
7ad3cb4a
Changes
1
Hide whitespace changes
Inline
Side-by-side
Showing
1 changed file
with
105 additions
and
62 deletions
+105
-62
install-sh
install-sh
+105
-62
No files found.
install-sh
View file @
844a3acc
#!/bin/sh
#
# install - install a program, script, or datafile
# This comes from X11R5 (mit/util/scripts/install.sh).
#
# Copyright 1991 by the Massachusetts Institute of Technology
# This originates from X11R5 (mit/util/scripts/install.sh), which was
# later released in X11R6 (xc/config/util/install.sh) with the
# following copyright and license.
#
# Permission to use, copy, modify, distribute, and sell this software and its
# documentation for any purpose is hereby granted without fee, provided that
# the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation, and that the name of M.I.T. not be used in advertising or
# publicity pertaining to distribution of the software without specific,
# written prior permission. M.I.T. makes no representations about the
# suitability of this software for any purpose. It is provided "as is"
# without express or implied warranty.
# Copyright (C) 1994 X Consortium
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
# AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
# TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
# Except as contained in this notice, the name of the X Consortium shall not
# be used in advertising or otherwise to promote the sale, use or other deal-
# ings in this Software without prior written authorization from the X Consor-
# tium.
#
#
# FSF changes to this file are in the public domain.
#
# Calling this script install-sh is preferred over install.sh, to prevent
# `make' implicit rules from creating a file called install from it
...
...
@@ -56,7 +74,7 @@ dir_arg=""
while
[
x
"
$1
"
!=
x
]
;
do
case
$1
in
-c
)
instcmd
=
"
$cpprog
"
-c
)
instcmd
=
$cpprog
shift
continue
;;
...
...
@@ -79,7 +97,7 @@ while [ x"$1" != x ]; do
shift
continue
;;
-s
)
stripcmd
=
"
$stripprog
"
-s
)
stripcmd
=
$stripprog
shift
continue
;;
...
...
@@ -106,128 +124,132 @@ done
if
[
x
"
$src
"
=
x
]
then
echo
"
install: no input file specified"
echo
"
$0
: no input file specified"
>
&2
exit
1
else
true
:
fi
if
[
x
"
$dir_arg
"
!=
x
]
;
then
dst
=
$src
src
=
""
if
[
-d
$dst
]
;
then
if
[
-d
"
$dst
"
]
;
then
instcmd
=
:
chmodcmd
=
""
else
instcmd
=
mkdir
instcmd
=
$mkdirprog
fi
else
# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
# might cause directories to be created, which would be especially bad
# might cause directories to be created, which would be especially bad
# if $src (and thus $dsttmp) contains '*'.
if
[
-f
$src
-o
-d
$src
]
if
[
-f
"
$src
"
]
||
[
-d
"
$src
"
]
then
true
:
else
echo
"
install:
$src
does not exist"
echo
"
$0
:
$src
does not exist"
>
&2
exit
1
fi
if
[
x
"
$dst
"
=
x
]
then
echo
"
install: no destination specified"
echo
"
$0
: no destination specified"
>
&2
exit
1
else
true
:
fi
# If destination is a directory, append the input filename; if your system
# does not like double slashes in filenames, you may need to add some logic
if
[
-d
$dst
]
if
[
-d
"
$dst
"
]
then
dst
=
"
$dst
"
/
`
basename
$src
`
dst
=
$dst
/
`
basename
"
$src
"
`
else
true
:
fi
fi
## this sed command emulates the dirname command
dstdir
=
`
echo
$dst
|
sed
-e
's,[^/]*$,,;s,/$,,;s,^$,.,'
`
dstdir
=
`
echo
"
$dst
"
|
sed
-e
's,[^/]*$,,;s,/$,,;s,^$,.,'
`
# Make sure that the destination directory exists.
# this part is taken from Noah Friedman's mkinstalldirs script
# Skip lots of stat calls in the usual case.
if
[
!
-d
"
$dstdir
"
]
;
then
defaultIFS
=
'
'
IFS
=
"
${
IFS
-
$
{
defaultIFS
}
}
"
defaultIFS
=
'
'
IFS
=
"
${
IFS
-
$
defaultIFS
}
"
oIFS
=
"
${
IFS
}
"
oIFS
=
$IFS
# Some sh's can't handle IFS=/ for some reason.
IFS
=
'%'
set
-
`
echo
${
dstdir
}
|
sed
-e
's@/@%@g'
-e
's@^%@/@'
`
IFS
=
"
${
oIFS
}
"
set
-
`
echo
"
$dstdir
"
|
sed
-e
's@/@%@g'
-e
's@^%@/@'
`
IFS
=
$oIFS
pathcomp
=
''
while
[
$#
-ne
0
]
;
do
pathcomp
=
"
${
pathcomp
}${
1
}
"
pathcomp
=
$pathcomp$1
shift
if
[
!
-d
"
$
{
pathcomp
}
"
]
;
if
[
!
-d
"
$
pathcomp
"
]
;
then
$mkdirprog
"
$
{
pathcomp
}
"
$mkdirprog
"
$
pathcomp
"
else
true
:
fi
pathcomp
=
"
${
pathcomp
}
/"
pathcomp
=
$pathcomp
/
done
fi
if
[
x
"
$dir_arg
"
!=
x
]
then
$doit
$instcmd
$dst
&&
$doit
$instcmd
"
$dst
"
&&
if
[
x
"
$chowncmd
"
!=
x
]
;
then
$doit
$chowncmd
$dst
;
else
true
;
fi
&&
if
[
x
"
$chgrpcmd
"
!=
x
]
;
then
$doit
$chgrpcmd
$dst
;
else
true
;
fi
&&
if
[
x
"
$stripcmd
"
!=
x
]
;
then
$doit
$stripcmd
$dst
;
else
true
;
fi
&&
if
[
x
"
$chmodcmd
"
!=
x
]
;
then
$doit
$chmodcmd
$dst
;
else
true
;
fi
if
[
x
"
$chowncmd
"
!=
x
]
;
then
$doit
$chowncmd
"
$dst
"
;
else
:
;
fi
&&
if
[
x
"
$chgrpcmd
"
!=
x
]
;
then
$doit
$chgrpcmd
"
$dst
"
;
else
:
;
fi
&&
if
[
x
"
$stripcmd
"
!=
x
]
;
then
$doit
$stripcmd
"
$dst
"
;
else
:
;
fi
&&
if
[
x
"
$chmodcmd
"
!=
x
]
;
then
$doit
$chmodcmd
"
$dst
"
;
else
:
;
fi
else
# If we're going to rename the final executable, determine the name now.
if
[
x
"
$transformarg
"
=
x
]
if
[
x
"
$transformarg
"
=
x
]
then
dstfile
=
`
basename
$dst
`
dstfile
=
`
basename
"
$dst
"
`
else
dstfile
=
`
basename
$dst
$transformbasename
|
dstfile
=
`
basename
"
$dst
"
$transformbasename
|
sed
$transformarg
`
$transformbasename
fi
# don't allow the sed command to completely eliminate the filename
if
[
x
"
$dstfile
"
=
x
]
if
[
x
"
$dstfile
"
=
x
]
then
dstfile
=
`
basename
$dst
`
dstfile
=
`
basename
"
$dst
"
`
else
true
:
fi
# Make a
temp file name
in the proper directory.
# Make a
couple of temp file names
in the proper directory.
dsttmp
=
$dstdir
/#inst.
$$
#
rmtmp
=
$dstdir
/#rm.
$$
#
#
Move or copy the file name to the temp name
#
Trap to clean up temp files at exit.
$doit
$instcmd
$src
$dsttmp
&&
trap
'status=$?; rm -f "$dsttmp" "$rmtmp" && exit $status'
0
trap
'(exit $?); exit'
1 2 13 15
trap
"rm -f
${
dsttmp
}
"
0
&&
# Move or copy the file name to the temp name
$doit
$instcmd
"
$src
"
"
$dsttmp
"
&&
# and set any options; do chmod last to preserve setuid bits
...
...
@@ -235,17 +257,38 @@ else
# ignore errors from any of these, just make sure not to ignore
# errors from the above "$doit $instcmd $src $dsttmp" command.
if
[
x
"
$chowncmd
"
!=
x
]
;
then
$doit
$chowncmd
$dsttmp
;
else
true
;
fi
&&
if
[
x
"
$chgrpcmd
"
!=
x
]
;
then
$doit
$chgrpcmd
$dsttmp
;
else
true
;
fi
&&
if
[
x
"
$stripcmd
"
!=
x
]
;
then
$doit
$stripcmd
$dsttmp
;
else
true
;
fi
&&
if
[
x
"
$chmodcmd
"
!=
x
]
;
then
$doit
$chmodcmd
$dsttmp
;
else
true
;
fi
&&
if
[
x
"
$chowncmd
"
!=
x
]
;
then
$doit
$chowncmd
"
$dsttmp
"
;
else
:
;
fi
&&
if
[
x
"
$chgrpcmd
"
!=
x
]
;
then
$doit
$chgrpcmd
"
$dsttmp
"
;
else
:
;
fi
&&
if
[
x
"
$stripcmd
"
!=
x
]
;
then
$doit
$stripcmd
"
$dsttmp
"
;
else
:
;
fi
&&
if
[
x
"
$chmodcmd
"
!=
x
]
;
then
$doit
$chmodcmd
"
$dsttmp
"
;
else
:
;
fi
&&
# Now remove or move aside any old file at destination location. We try this
# two ways since rm can't unlink itself on some systems and the destination
# file might be busy for other reasons. In this case, the final cleanup
# might fail but the new file should still install successfully.
{
if
[
-f
"
$dstdir
/
$dstfile
"
]
then
$doit
$rmcmd
-f
"
$dstdir
/
$dstfile
"
2>/dev/null
||
$doit
$mvcmd
-f
"
$dstdir
/
$dstfile
"
"
$rmtmp
"
2>/dev/null
||
{
echo
"
$0
: cannot unlink or rename
$dstdir
/
$dstfile
"
>
&2
(
exit
1
)
;
exit
}
else
:
fi
}
&&
# Now rename the file to the real destination.
$doit
$rmcmd
-f
$dstdir
/
$dstfile
&&
$doit
$mvcmd
$dsttmp
$dstdir
/
$dstfile
$doit
$mvcmd
"
$dsttmp
"
"
$dstdir
/
$dstfile
"
fi
&&
# The final little trick to "correctly" pass the exit status to the exit trap.
exit
0
{
(
exit
0
)
;
exit
}
Write
Preview
Markdown
is supported
0%
Try again
or
attach a new file
Attach a file
Cancel
You are about to add
0
people
to the discussion. Proceed with caution.
Finish editing this message first!
Cancel
Please
register
or
sign in
to comment